Skip to main content
POST
/
calls
/
{call_control_id}
/
actions
/
refer
JavaScript
import Telnyx from 'telnyx';

const client = new Telnyx({
  apiKey: process.env['TELNYX_API_KEY'], // This is the default and can be omitted
});

const response = await client.calls.actions.refer('call_control_id', {
  sip_address: 'sip:username@sip.non-telnyx-address.com',
});

console.log(response.data);
import os
from telnyx import Telnyx

client = Telnyx(
api_key=os.environ.get("TELNYX_API_KEY"), # This is the default and can be omitted
)
response = client.calls.actions.refer(
call_control_id="call_control_id",
sip_address="sip:username@sip.non-telnyx-address.com",
)
print(response.data)
package main

import (
"context"
"fmt"

"github.com/team-telnyx/telnyx-go"
"github.com/team-telnyx/telnyx-go/option"
)

func main() {
client := telnyx.NewClient(
option.WithAPIKey("My API Key"),
)
response, err := client.Calls.Actions.Refer(
context.TODO(),
"call_control_id",
telnyx.CallActionReferParams{
SipAddress: "sip:username@sip.non-telnyx-address.com",
},
)
if err != nil {
panic(err.Error())
}
fmt.Printf("%+v\n", response.Data)
}
package com.telnyx.sdk.example;

import com.telnyx.sdk.client.TelnyxClient;
import com.telnyx.sdk.client.okhttp.TelnyxOkHttpClient;
import com.telnyx.sdk.models.calls.actions.ActionReferParams;
import com.telnyx.sdk.models.calls.actions.ActionReferResponse;

public final class Main {
private Main() {}

public static void main(String[] args) {
TelnyxClient client = TelnyxOkHttpClient.fromEnv();

ActionReferParams params = ActionReferParams.builder()
.callControlId("call_control_id")
.sipAddress("sip:username@sip.non-telnyx-address.com")
.build();
ActionReferResponse response = client.calls().actions().refer(params);
}
}
require "telnyx"

telnyx = Telnyx::Client.new(api_key: "My API Key")

response = telnyx.calls.actions.refer("call_control_id", sip_address: "sip:username@sip.non-telnyx-address.com")

puts(response)
<?php

require_once dirname(__DIR__) . '/vendor/autoload.php';

use Telnyx\Client;
use Telnyx\Core\Exceptions\APIException;

$client = new Client(apiKey: getenv('TELNYX_API_KEY') ?: 'My API Key');

try {
$response = $client->calls->actions->refer(
'call_control_id',
sipAddress: 'sip:username@sip.non-telnyx-address.com',
clientState: 'aGF2ZSBhIG5pY2UgZGF5ID1d',
commandID: '891510ac-f3e4-11e8-af5b-de00688a4901',
customHeaders: [
['name' => 'head_1', 'value' => 'val_1'],
['name' => 'head_2', 'value' => 'val_2'],
],
sipAuthPassword: 'sip_auth_password',
sipAuthUsername: 'sip_auth_username',
sipHeaders: [['name' => 'User-to-User', 'value' => 'value']],
);

var_dump($response);
} catch (APIException $e) {
echo $e->getMessage();
}
telnyx calls:actions refer \
--api-key 'My API Key' \
--call-control-id call_control_id \
--sip-address sip:username@sip.non-telnyx-address.com
curl --request POST \
--url https://api.telnyx.com/v2/calls/{call_control_id}/actions/refer \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"sip_address": "sip:username@sip.non-telnyx-address.com"
}
'
{
  "data": {
    "result": "ok"
  }
}

Authorizations

Authorization
string
header
required

Bearer authentication header of the form Bearer <token>, where <token> is your auth token.

Path Parameters

call_control_id
string
required

Unique identifier and token for controlling the call

Body

application/json

Refer request

sip_address
string
required

The SIP URI to which the call will be referred to.

Example:

"sip:username@sip.non-telnyx-address.com"

client_state
string

Use this field to add state to every subsequent webhook. It must be a valid Base-64 encoded string.

Example:

"aGF2ZSBhIG5pY2UgZGF5ID1d"

command_id
string

Use this field to avoid execution of duplicate commands. Telnyx will ignore subsequent commands with the same command_id as one that has already been executed.

Example:

"891510ac-f3e4-11e8-af5b-de00688a4901"

custom_headers
Custom SIP Header · object[]

Custom headers to be added to the SIP INVITE.

Example:
[
{ "name": "head_1", "value": "val_1" },
{ "name": "head_2", "value": "val_2" }
]
sip_auth_username
string

SIP Authentication username used for SIP challenges.

sip_auth_password
string

SIP Authentication password used for SIP challenges.

sip_headers
SIP Header · object[]

SIP headers to be added to the request. Currently only User-to-User header is supported.

Example:
[
{ "name": "User-to-User", "value": "value" }
]

Response

Successful response upon making a call control command.

data
Call Control Command Result · object
Example:
{ "result": "ok" }